#ifndef __CBUFFER_H
#define __CBUFFER_H

#include <stdlib.h>
#include <string.h>

class CBuffer {
  size_t len;
  char *buffer;
  CBuffer(const CBuffer&);
 public:
  CBuffer& operator=(const char*sztmp);
  size_t length() { return strlen(buffer); }
  char* data() { return buffer; }
  CBuffer(size_t n = 16) : len(n)
    {
      buffer = new char[len];
      buffer[0] = '\0';
    }
  ~CBuffer() { delete [] buffer; }
  char& operator[](int i);
};

#endif
