#ifndef __CBAR_H
#define __CBAR_H

#include <FL/Fl.H>
#include <FL/fl_draw.H>
#include <FL/Fl_Box.H>

class CBar : public Fl_Box 
{
private:
  unsigned char val;
  int fs;
  virtual void draw();

  void setfs();

public:
  CBar(int x,int y,int w,int h,char *c = NULL) : Fl_Box(x,y,w,h,c), val(0) { setfs(); }
  virtual ~CBar() {}
  bool value(unsigned char _v);
  unsigned char value() { return val; }
};
#endif
